'use strict';

var process$1 = require('process');
var boxen = require('@visulima/boxen');
var colorize = require('@visulima/colorize');
var server = require('@visulima/pail/server');
var Xe = require('camelcase');
var Ze = require('command-line-args');
var I = require('cli-table3');
var re = require('@visulima/colorize/template');
var ae = require('os');
var fastestLevenshtein = require('fastest-levenshtein');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Xe__default = /*#__PURE__*/_interopDefault(Xe);
var Ze__default = /*#__PURE__*/_interopDefault(Ze);
var I__default = /*#__PURE__*/_interopDefault(I);
var re__default = /*#__PURE__*/_interopDefault(re);
var ae__default = /*#__PURE__*/_interopDefault(ae);

var ie=[{description:"Turn on verbose output",group:"global",name:"verbose",type:Boolean},{description:"Turn on debugging output",group:"global",name:"debug",type:Boolean},{alias:"h",description:"Print out helpful usage information",group:"global",name:"help",type:Boolean},{alias:"q",description:"Silence output",group:"global",name:"quiet",type:Boolean},{alias:"V",description:"Print version info",group:"global",name:"version",type:Boolean},{description:"Turn off colored output",group:"global",name:"no-color",type:Boolean},{description:"Force colored output",group:"global",name:"color",type:Boolean}],b=ie;var se=o=>o?re__default.default(Object.assign([],{raw:[o.replaceAll("`","\\`")]})):"",m=se;var C=class{lines;constructor(){this.lines=[];}add(e){this.lines.push(e);}toString(){return this.lines.join(ae__default.default.EOL)}header(e){this.add(colorize.bold(e)),this.lines.push("");}},T=C;var v={chars:{bottom:"","bottom-left":"","bottom-mid":"","bottom-right":"",left:" ","left-mid":"",mid:"","mid-mid":"",middle:" ",right:"","right-mid":"",top:"","top-left":"","top-mid":"","top-right":""},colWidths:[40,60],style:{border:[],compact:!0,head:[],"padding-left":2,"padding-right":1},wordWrap:!0},x=class extends T{constructor(e){if(super(),e.header&&this.header(m(e.header)),e.content){if(e.raw)if(Array.isArray(e.content)&&e.content.every(t=>typeof t=="string"))e.content.forEach(t=>{Array.isArray(t)?t.forEach(n=>this.add(m(n))):this.add(m(t));});else if(typeof e.content=="string")this.add(m(e.content));else throw new TypeError("Invalid raw content, must be a string or array of strings.");else this.add(this.getContentLines(e.content));this.add("");}}getContentLines(e){if(typeof e=="string"){let t=new I__default.default({...v,colWidths:[80]});return t.push([m(e)]),t.toString()}if(Array.isArray(e)&&e.every(t=>typeof t=="string"||Array.isArray(t)&&t.every(n=>typeof n=="string"))){let t=new I__default.default({...v});return e.forEach(n=>{Array.isArray(n)?t.push(n.map(r=>m(r))):t.push([m(n)]);}),t.toString()}if(typeof e=="object"){let t=e;if(!t.options||!t.data)throw new Error(`Must have an "options" or "data" property
${JSON.stringify(e)}`);let n=new I__default.default({...v,...t.options,style:{...v.style,...t.options.style}});return t.data.forEach(r=>{Array.isArray(r)?n.push(r.map(i=>m(i))):n.push([m(r)]);}),n.toString()}throw new Error(`invalid input - 'content' must be a string, array of strings or a object:

${JSON.stringify(e)}`)}},V=x;var w=class extends T{constructor(e){super();let t=e.optionList??[],n=Array.isArray(e.hide)?e.hide:[e.hide].filter(Boolean),r=Array.isArray(e.group)?e.group:[e.group].filter(Boolean);n.length>0&&(t=t.filter(s=>!n.includes(s.name))),e.header&&this.header(m(e.header)),r.length>0&&(t=t.filter(s=>{let a=r.includes("_none")&&!s.group,l=this.intersect(Array.isArray(s.group)?s.group:[s.group],r);return a||l?s:void 0}));let i=new I__default.default({chars:{bottom:"","bottom-left":"","bottom-mid":"","bottom-right":"",left:" ","left-mid":"",mid:"","mid-mid":"",middle:" ",right:"","right-mid":"",top:"","top-left":"","top-mid":"","top-right":""},colWidths:[40,40],style:{"padding-left":2,"padding-right":1},wordWrap:!0});t.forEach(s=>i.push([this.getOptionNames(s,e.reverseNameOrder??!1,e.isArgument??!1),m(s.description)])),this.add(i.toString()),this.lines.push("");}getOptionNames(e,t,n){if(!e.name)throw new TypeError("Invalid option definition, name is required.");let r=e.type?e.type.name.toLowerCase():"string",i=e.multiple||e.lazyMultiple?"[]":"";r=m(e.typeLabel??`{underline ${r}${i}}`);let s;if(e.alias)if(e.name){let a=n?e.name:`{yellow --${e.name}}`;s=t?m(`{bold ${a}}, {bold -${e.alias}} ${r}`):m(`{bold -${e.alias}}, {bold ${a}} ${r}`);}else t?s=m(`{bold -${e.alias}} ${r}`):s=m(`{bold -${e.alias}} ${r}`);else s=m(`{bold ${n?e.name:`{yellow --${e.name}}`}} ${r}`);return s}intersect(e,t){return e.some(n=>t.includes(n))}},B=w;var me=o=>(Array.isArray(o)?o:[o]).length===0?"":`
${o.map(t=>t.optionList?new B(t).toString():new V(t).toString()).join(`
`)}`,N=me;var U="__Other",k=o=>o.charAt(0).toUpperCase()+o.slice(1),de=(o,e,t,n)=>{o.debug("no command given, printing general help...");let r=[...new Set(t.values())].filter(s=>!s.hidden);n&&(r=r.filter(s=>s.group===n));let i=r.reduce((s,a)=>{let l=a.group??U;return s[l]||(s[l]=[]),s[l].push(a),s},{});o.raw(N([{content:`{cyan ${e.getCliName()}} {green <command>} [positional arguments] {yellow [options]}`,header:"{inverse.cyan  Usage }"},...Object.keys(i).map(s=>({content:i[s].map(a=>{let l="";return typeof a.alias=="string"?l=a.alias:Array.isArray(a.alias)&&(l=a.alias.join(", ")),l!==""&&(l=` [${l}]`),[`{green ${a.name}} ${l}`,a.description??""]}),header:s===U||n?`{inverse.green  Available${n?` ${k(n)}`:""} Commands }`:` {inverse.green  ${k(s)} }`})),t.has("help")?{header:"{inverse.yellow  Command Options }",optionList:t.get("help").options?.filter(s=>!s.hidden)}:void 0,{header:"{inverse.yellow  Global Options }",optionList:b},{content:`Run "{cyan ${e.getCliName()}} {green help <command>}" or "{cyan ${e.getCliName()}} {green <command>} {yellow --help}" for help with a specific command.`,raw:!0}].filter(Boolean)));},ce=(o,e,t,n)=>{let r=t.get(n),i=[];if(i.push({content:`{cyan ${e.getCliName()}} {green ${r.name}}${r.argument?" [positional arguments]":""}${r.options?" [options]":""}`,header:"{inverse.cyan  Usage }"}),r.description&&i.push({content:r.description,header:"{inverse.green  Description }"}),r.argument&&i.push({header:"Command Positional Arguments",isArgument:!0,optionList:[r.argument]}),Array.isArray(r.options)&&r.options.length>0&&i.push({header:"{inverse.yellow  Command Options }",optionList:r.options.filter(s=>!s.hidden)}),i.push({header:"{inverse.yellow  Global Options }",optionList:b}),r.alias!==void 0&&r.alias.length>0){let s=r.alias;typeof r.alias=="string"&&(s=[r.alias]),i.splice(1,0,{content:s,header:"Alias(es)"});}Array.isArray(r.examples)&&r.examples.length>0&&i.push({content:r.examples,header:"Examples"}),o.raw(N(i));},P=class{name="help";options=[{description:"Display only the specified group",name:"group",type:String}];commands;constructor(e){this.commands=e;}execute(e){let{commandName:t,logger:n,options:r,runtime:i}=e,{footer:s,header:a}=i.getCommandSection();a&&n.raw(m(a)),t==="help"?de(n,i,this.commands,r?.group):ce(n,i,this.commands,t),s&&n.raw(m(s));}},M=P;var j={alias:["v","V"],description:"Output the version number",execute:({logger:o,runtime:e})=>{let t=e.getPackageVersion();t===void 0?(o.warn("Unknown version"),o.debug("The version number was not provided by the cli constructor.")):o.info(t);},name:"version",options:[],usage:[]};var O="positionals";var L=class{result;argv;options;argument;command;commandName;runtime;logger;constructor(e,t){this.commandName=e,this.command=t;}},Y=L;var ge=()=>{let o=process.env.CEREBRO_MIN_NODE_VERSION?Number(process.env.CEREBRO_MIN_NODE_VERSION):18,e=process.version.replace("v","");Number(/v([^.]+)/.exec(process.version)[1])<o&&(console.log(`cerebro supports a minimum Node version of ${o}. You have ${e}. Read our version support policy: https://github.com/visulima/visulima#supported-nodejs-versions`),process.exit(1));},F=ge;var ue=/^-{1,2}(\w+)(=(\w+))?$/,fe=(o,e)=>{let t=ue.exec(o);if(t==null)return {};let n=t[1],r=e.find(i=>i.name===n||i.alias===n);return r!==void 0?{argName:r.name,argValue:t[3],option:r}:{}},E=fe;var he=o=>o.type?.name==="Boolean",f=he;var G=(o,e)=>{if(e.type===void 0)return o;if(e.type.name==="Boolean"){if(o==="true"||o==="1")return e.type(!0);if(o==="false"||o==="0")return e.type(!1)}return e.type(o)},be=new Set(["1","0","true","false"]),ye=(o,e)=>{let t=(n,r)=>{let{argName:i,argValue:s,option:a}=E(r,e),{lastOption:l}=n;return a&&f(a)&&s&&i?n.partial[i]=G(s,a):n.lastName&&l&&f(l)&&be.has(r)&&(n.partial[n.lastName]=G(r,l)),{lastName:i,lastOption:a,partial:n.partial}};return o.reduce(t,{partial:{}}).partial},q=ye;var Oe=o=>{let e=o.type?o.type.name.toLowerCase():"string",t=o.multiple??o.lazyMultiple?"[]":"";return e&&(e=e==="boolean"?"":`{underline ${e}${t}}`),e},Te=o=>(f(o)||(o.typeLabel=o.typeLabel??Oe(o),o.defaultOption&&(o.typeLabel=`${o.typeLabel} (D)`),o.required&&(o.typeLabel=`${o.typeLabel} (R)`)),o),J=Te;var ve=new Set(["1","0","true","false"]),Ee=(o,e)=>{let t=(n,r)=>{let{argValue:i,option:s}=E(r,e),{lastOption:a}=n;if(a&&f(a)&&ve.has(r)){let l=[...n.args];return l.pop(),{args:l}}return s&&f(s)&&i?{args:n.args}:{args:[...n.args,r],lastOption:s}};return o.reduce(t,{args:[]}).args},W=Ee;var Ce=new RegExp(/^-([^\d-])$/),Ie=new RegExp(/^--(\S+)/),xe=new RegExp(/^-([^\d-]{2,})$/),we=o=>Ce.test(o)||Ie.test(o)||xe.test(o),Ne=(o,e)=>{let t=e[0]&&we(e[0])||e.length===0?null:e.shift()??null;if(!o.includes(t)){let n=new Error(`Command not recognised: ${t}`);throw n.command=t,n.name="INVALID_COMMAND",n}return {argv:e,command:t}},H=Ne;var Le=(o,e)=>fastestLevenshtein.distance(o,e)<=o.length/3||e.includes(o),Ae=(o,e)=>{let t=o.toLowerCase();return e.filter(n=>Le(n.toLowerCase(),t))},A=Ae;var $e=(o,e)=>o.filter(t=>t.required&&e[t.name]==null).filter(t=>t.type?.name==="Boolean"?(e[t.name]=!1,!1):!0),K=$e;var _e=o=>{let e=new Map;return o.forEach(t=>{e.set(t.name,{...e.get(t.name),...t});}),[...e.values()]},z=_e;var De=()=>!!process.versions.electron,Se=()=>De()&&!process.defaultApp,Re=()=>Se()?0:1,Ve=o=>o.slice(Re()+1),Q=Ve;var Be=" ",Ue=(o,e)=>o.length===e.length&&o.every((t,n)=>t===e[n]),ke=o=>typeof o=="string"?o.split(Be):Ue(o,process.argv)?Q(o):o,X=ke;var Me=o=>{process.on("uncaughtException",e=>{o.error(`Uncaught exception: ${e}`),e?.stack&&o.error(e.stack),process.exit(1);}),process.on("unhandledRejection",e=>{o.error(`Promise rejection: ${e}`),e?.stack&&o.error(e.stack),process.exit(1);});},Z=Me;var et="CI"in process$1.env&&("GITHUB_ACTIONS"in process$1.env||"GITLAB_CI"in process$1.env||"CIRCLECI"in process$1.env),_=process$1.env.NODE_ENV==="test"||process$1.env.TEST!=="false",tt=o=>o.charAt(0).toLowerCase()+o.slice(1),D=class{logger;argv;cwd;cliName;packageVersion;packageName;extensions=[];commands;defaultCommand;updateNotifierOptions;commandSection;constructor(e,t={}){let{argv:n,cwd:r,packageName:i,packageVersion:s}={argv:process$1.argv,cwd:process$1.cwd(),...t};this.argv=X(n),this.argv.includes("--quiet")||this.argv.includes("-q")?process$1.env.CEREBRO_OUTPUT_LEVEL=String(16):this.argv.includes("--verbose")||this.argv.includes("-v")?process$1.env.CEREBRO_OUTPUT_LEVEL=String(64):this.argv.includes("--debug")||this.argv.includes("-vvv")||"DEBUG"in process$1.env?process$1.env.CEREBRO_OUTPUT_LEVEL=String(128):process$1.env.CEREBRO_OUTPUT_LEVEL=String(32);let a={32:"informational",64:"trace",128:"debug"};this.logger=server.createPail({logLevel:process$1.env.CEREBRO_OUTPUT_LEVEL?a[process$1.env.CEREBRO_OUTPUT_LEVEL]??"informational":"informational",...t.logger}),process$1.env.CEREBRO_OUTPUT_LEVEL===String(16)&&this.logger.disable(),F(),Z(this.logger),this.cliName=e,this.packageVersion=s,this.packageName=i,this.cwd=r,this.defaultCommand="help",this.commandSection={header:`${this.cliName}${this.packageVersion?` v${this.packageVersion}`:""}`},this.commands=new Map,this.addCoreExtensions(),this.addCommand(j),this.addCommand(new M(this.commands));}setCommandSection(e){return this.commandSection=e,this}getCommandSection(){return this.commandSection}setDefaultCommand(e){return this.defaultCommand=e,this}addCommand(e){if(this.commands.has(e.name))throw new Error(`Ignored command with name "${e.name}, it was found in the command list."`);if(e.options?.map(t=>J(t)),this.validateDoubleOptions(e),this.addNegatableOption(e),e.options?.forEach(t=>{t.__camelCaseName__=Xe__default.default(t.name);}),this.commands.set(e.name,e),e.alias!==void 0){let t=e.alias;typeof e.alias=="string"&&(t=[e.alias]),t.forEach(n=>{if(this.logger.debug("adding alias",n),this.commands.has(n))throw new Error(`Ignoring command alias "${n}, command with the same name was found."`);this.commands.set(n,e);});}return this}addExtension(e){return this.extensions.push(e),this}enableUpdateNotifier(e={}){if(!this.packageName||!this.packageVersion)throw new Error("Cannot enable update notifier without package name and version.");let t=Object.keys(e);if(t.length>0&&!t.includes("alwaysRun")&&!t.includes("distTag")&&!t.includes("updateCheckInterval"))throw new Error("Invalid update notifier options, please check the documentation.");return this.updateNotifierOptions={alwaysRun:!1,debug:process$1.env.CEREBRO_OUTPUT_LEVEL===String(128),distTag:"latest",pkg:{name:this.packageName,version:this.packageVersion},updateCheckInterval:1e3*60*60*24,...e},this}getCliName(){return this.cliName}getPackageVersion(){return this.packageVersion}getPackageName(){return this.packageName}getCommands(){return this.commands}getCwd(){return this.cwd}async run(e={}){let t=[...this.commands.keys()],n;this.logger.debug(`process.execPath: ${process$1.execPath}`),this.logger.debug(`process.execArgv: ${process$1.execArgv.join(" ")}`),this.logger.debug(`process.argv: ${process$1.argv.join(" ")}`);try{n=H([null,...t],this.argv);}catch(u){if(u.name==="INVALID_COMMAND"&&u.command){let S="",R=A(u.command,[...this.commands.keys()]);R.length>0&&(S=` Did you mean: \r
    - ${R.join(`    \r
- `)}`),this.logger.error(`"${u.command}" is not an available command.${S}`);}else this.logger.error(u);return _?void 0:process$1.exit(1)}let r=n.command??this.defaultCommand,i=this.commands.get(r);if(typeof i.execute!="function")return this.logger.error(`Command "${i.name}" has no function to execute.`),_?void 0:process$1.exit(1);let s=n.argv;this.logger.debug(`command '${r}' found, parsing command args: ${s.join(", ")}`);let a=z([...i.options??[],...b]);a.forEach(u=>{if(u.multiple&&u.lazyMultiple)throw new Error(`Argument "${u.name}" cannot have both multiple and lazyMultiple options, please choose one.`)}),i.argument&&(this.logger.debug("command has positional argument, parsing them..."),a=[{defaultOption:!0,description:i.argument?.description,group:"positionals",multiple:!0,name:O,type:i.argument?.type,typeLabel:i.argument?.typeLabel},...a]);let l=Ze__default.default(a,{argv:W(s,i.options??[]),camelCase:!0,partial:!0,stopAtFirstUnknown:!0}),h=q(s,i.options??[]),g={...l,_all:{...l._all,...h}};this.validateCommandOptions(a,g,i);let c=new Y(i.name,i);c.runtime=this,await this.registerExtensions(c),await this.updateNotifier(c);let{_all:y,positionals:ne}=g;return y[O]&&delete y[O],c.argument=ne?.[O]??[],c.argv=this.argv,c.options={...y,...e},this.mapNegatableOptions(c,i),this.mapImpliesOptions(c,i),this.validateCommandArgsForConflicts(a,c.options,i),this.logger.debug("command options parsed from options:"),this.logger.debug(JSON.stringify(c.options,null,2)),this.logger.debug("command argument parsed from argument:"),this.logger.debug(JSON.stringify(c.argument,null,2)),await this.prepareToolboxResult(g,c,i),_?void 0:process$1.exit(0)}validateDoubleOptions(e){if(Array.isArray(e.options)){let t=e.options.reduce((i,s)=>{let a=`${s.name}-${s.alias}`;return i[a]||(i[a]=[]),i[a].push(s),i},{}),n=Object.values(t).filter(i=>i.length>1),r="";if(n.forEach(i=>{let s=i[0],a=i[1],l="alias";s.name===a.name&&(l="name",s.alias===a.alias&&(l+=" and alias")),r+=`Cannot add option ${l} "${JSON.stringify(a)}" to command "${e.name}" due to conflicting option ${JSON.stringify(s)}
`;}),r.length>0)throw new Error(r)}}addCoreExtensions(){this.addExtension({execute:e=>{e.logger=this.logger;},name:"logger"});}async prepareToolboxResult(e,t,n){if(e.global?.help){this.logger.debug("'--help' option found, running 'help' for given command...");let r=this.commands.get("help");if(!r)throw new Error("Help command not found.");await r.execute(t);return}if(e.global?.version||e.global?.V){this.logger.debug("'--version' option found, running 'version' for given command...");let r=this.commands.get("version");if(!r)throw new Error("Version command not found.");await r.execute(t);return}await n.execute(t);}async updateNotifier({logger:e}){if(this.updateNotifierOptions&&this.updateNotifierOptions.alwaysRun||!(process$1.env.NO_UPDATE_NOTIFIER||process$1.env.NODE_ENV==="test"||this.argv.includes("--no-update-notifier")||et)&&this.updateNotifierOptions){e.raw("Checking for updates...");let n=await(await import('./has-new-version-BHGL5WIA.cjs').then(r=>r.default))(this.updateNotifierOptions);if(n){let r="Update available "+colorize.dim(this.packageVersion+"")+colorize.reset(" \u2192 ")+colorize.green(n);this.logger.error(boxen.boxen(r,{borderColor:i=>colorize.yellow(i),borderStyle:"round",margin:1,padding:1,textAlignment:"center"}));}}}validateCommandOptions(e,t,n){let r=K(e,t);if(r.length>0)throw new Error(`You called the command "${n.name}" without the required options: ${r.map(i=>i.name).join(", ")}`);if(t._unknown&&t._unknown.length>0){let i=[];if(t._unknown.forEach(s=>{let a=s.startsWith("--"),l=`Found unknown ${a?"option":"argument"} "${s}"`;if(a){let h=A(s.replace("--",""),[...(n.options??[]).map(g=>g.name),...b.map(g=>g.name)]);if(h.length>0){let[g,...c]=h.map(y=>`--${y}`);l+=c.length>0?`, did you mean ${g} or ${c.join(", ")}?`:`, did you mean ${g}?`;}}i.push(l);}),i.length>0)throw new Error(i.join(`
`))}}validateCommandArgsForConflicts(e,t,n){let r=e.filter(i=>i.conflicts!==void 0);if(r.length>0){let i=r.find(s=>Array.isArray(s.conflicts)?s.conflicts.some(a=>t[a]!==void 0):t[s.conflicts]!==void 0);if(i)throw new Error(`You called the command "${n.name}" with conflicting options: ${i.name} and ${typeof i.conflicts=="string"?i.conflicts:i.conflicts?.join(", ")}`)}}addNegatableOption(e){Array.isArray(e.options)&&e.options.forEach(t=>{if(t.name.startsWith("no-")&&!e.options.some(n=>n.name===t.name.replace("no-",""))){if(t.type!==Boolean){this.logger.debug(`Cannot add negated option "${t.name}" to command "${e.name}" because it is not a boolean.`);return}let n={...t,defaultValue:t.defaultValue===void 0?!0:!t.defaultValue,name:`${t.name.replace("no-","")}`};e.options.push(n);}});}async registerExtensions(e){let t=async n=>typeof n.execute!="function"?(this.logger.warn(`Skipped ${n.name} because execute is not a function.`),null):(await n.execute(e),null);for(let n of this.extensions)await t(n);}mapNegatableOptions(e,t){Object.entries(e.options).forEach(([n,r])=>{if(/^no\w+/.test(n)){let i=tt(n.replace("no",""));this.logger.debug(`mapping negated option "${n}" to "${i}"`),e.options[i]=!r,t.options?.forEach(s=>{s.name===i&&(s.__negated__=!0);});}});}mapImpliesOptions(e,t){Object.keys(e.options).forEach(n=>{let r=t.options?.find(i=>i.__camelCaseName__===n&&i.__negated__===void 0&&i.implies!==void 0);if(r?.implies){let i=r.implies;Object.entries(i).forEach(([s,a])=>{if(e.options[s]===void 0)e.options[s]=a;else {let l=t.options?.find(h=>h.name===s);(l?.defaultValue===void 0||e.options[s]===l.defaultValue)&&(e.options[s]=a);}});}});}},ot=D;

module.exports = ot;
//# sourceMappingURL=out.js.map

module.exports = module.exports;
//# sourceMappingURL=index.cjs.map